Index: XIOS3/trunk/src/generate_fortran_interface.cpp
===================================================================
--- XIOS3/trunk/src/generate_fortran_interface.cpp	(revision 2614)
+++ XIOS3/trunk/src/generate_fortran_interface.cpp	(revision 2616)
@@ -335,4 +335,12 @@
   file.close();
 
+  file.open((path+"redistribute_domain_interface_attr.F90").c_str());
+  redistributeDomain.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"icredistribute_domain_attr.cpp").c_str());
+  redistributeDomain.generateCInterface(file);
+  file.close();
+  
   file.open((path+"iredistribute_domain_attr.F90").c_str());
   redistributeDomain.generateFortranInterface(file);
@@ -444,4 +452,12 @@
   file.close();
 
+  file.open((path+"redistribute_axis_interface_attr.F90").c_str());
+  redistributeAxis.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"icredistribute_axis_attr.cpp").c_str());
+  redistributeAxis.generateCInterface(file);
+  file.close();
+
   file.open((path+"iredistribute_axis_attr.F90").c_str());
   redistributeAxis.generateFortranInterface(file);
@@ -501,4 +517,12 @@
   file.close();
 
+  file.open((path+"redistribute_scalar_interface_attr.F90").c_str());
+  redistributeScalar.generateFortran2003Interface(file);
+  file.close();
+
+  file.open((path+"icredistribute_scalar_attr.cpp").c_str());
+  redistributeScalar.generateCInterface(file);
+  file.close();
+
   file.open((path+"iredistribute_scalar_attr.F90").c_str());
   redistributeScalar.generateFortranInterface(file);
Index: XIOS3/trunk/src/interface/c_attr/icaxis_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 2616)
@@ -143,4 +143,27 @@
 
 
+  void cxios_set_axis_chunking_weight(axis_Ptr axis_hdl, double chunking_weight)
+  {
+    CTimer::get("XIOS").resume();
+    axis_hdl->chunking_weight.setValue(chunking_weight);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_axis_chunking_weight(axis_Ptr axis_hdl, double* chunking_weight)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight = axis_hdl->chunking_weight.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_axis_chunking_weight(axis_Ptr axis_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = axis_hdl->chunking_weight.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_axis_comment(axis_Ptr axis_hdl, const char * comment, int comment_size)
   {
Index: XIOS3/trunk/src/interface/c_attr/icaxisgroup_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 2616)
@@ -143,4 +143,27 @@
 
 
+  void cxios_set_axisgroup_chunking_weight(axisgroup_Ptr axisgroup_hdl, double chunking_weight)
+  {
+    CTimer::get("XIOS").resume();
+    axisgroup_hdl->chunking_weight.setValue(chunking_weight);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_axisgroup_chunking_weight(axisgroup_Ptr axisgroup_hdl, double* chunking_weight)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight = axisgroup_hdl->chunking_weight.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_axisgroup_chunking_weight(axisgroup_Ptr axisgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = axisgroup_hdl->chunking_weight.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_axisgroup_comment(axisgroup_Ptr axisgroup_hdl, const char * comment, int comment_size)
   {
Index: XIOS3/trunk/src/interface/c_attr/iccontext_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 2616)
@@ -40,4 +40,209 @@
 
 
+  void cxios_set_context_default_gatherer(context_Ptr context_hdl, const char * default_gatherer, int default_gatherer_size)
+  {
+    std::string default_gatherer_str;
+    if (!cstr2string(default_gatherer, default_gatherer_size, default_gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_gatherer.setValue(default_gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_gatherer(context_Ptr context_hdl, char * default_gatherer, int default_gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_gatherer.getInheritedValue(), default_gatherer, default_gatherer_size))
+      ERROR("void cxios_get_context_default_gatherer(context_Ptr context_hdl, char * default_gatherer, int default_gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_gatherer(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_pool(context_Ptr context_hdl, const char * default_pool, int default_pool_size)
+  {
+    std::string default_pool_str;
+    if (!cstr2string(default_pool, default_pool_size, default_pool_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_pool.setValue(default_pool_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_pool(context_Ptr context_hdl, char * default_pool, int default_pool_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_pool.getInheritedValue(), default_pool, default_pool_size))
+      ERROR("void cxios_get_context_default_pool(context_Ptr context_hdl, char * default_pool, int default_pool_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_pool(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_pool.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_pool_gatherer(context_Ptr context_hdl, const char * default_pool_gatherer, int default_pool_gatherer_size)
+  {
+    std::string default_pool_gatherer_str;
+    if (!cstr2string(default_pool_gatherer, default_pool_gatherer_size, default_pool_gatherer_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_pool_gatherer.setValue(default_pool_gatherer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_pool_gatherer(context_Ptr context_hdl, char * default_pool_gatherer, int default_pool_gatherer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_pool_gatherer.getInheritedValue(), default_pool_gatherer, default_pool_gatherer_size))
+      ERROR("void cxios_get_context_default_pool_gatherer(context_Ptr context_hdl, char * default_pool_gatherer, int default_pool_gatherer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_pool_gatherer(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_pool_gatherer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_pool_reader(context_Ptr context_hdl, const char * default_pool_reader, int default_pool_reader_size)
+  {
+    std::string default_pool_reader_str;
+    if (!cstr2string(default_pool_reader, default_pool_reader_size, default_pool_reader_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_pool_reader.setValue(default_pool_reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_pool_reader(context_Ptr context_hdl, char * default_pool_reader, int default_pool_reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_pool_reader.getInheritedValue(), default_pool_reader, default_pool_reader_size))
+      ERROR("void cxios_get_context_default_pool_reader(context_Ptr context_hdl, char * default_pool_reader, int default_pool_reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_pool_reader(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_pool_reader.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_pool_writer(context_Ptr context_hdl, const char * default_pool_writer, int default_pool_writer_size)
+  {
+    std::string default_pool_writer_str;
+    if (!cstr2string(default_pool_writer, default_pool_writer_size, default_pool_writer_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_pool_writer.setValue(default_pool_writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_pool_writer(context_Ptr context_hdl, char * default_pool_writer, int default_pool_writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_pool_writer.getInheritedValue(), default_pool_writer, default_pool_writer_size))
+      ERROR("void cxios_get_context_default_pool_writer(context_Ptr context_hdl, char * default_pool_writer, int default_pool_writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_pool_writer(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_pool_writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_reader(context_Ptr context_hdl, const char * default_reader, int default_reader_size)
+  {
+    std::string default_reader_str;
+    if (!cstr2string(default_reader, default_reader_size, default_reader_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_reader.setValue(default_reader_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_reader(context_Ptr context_hdl, char * default_reader, int default_reader_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_reader.getInheritedValue(), default_reader, default_reader_size))
+      ERROR("void cxios_get_context_default_reader(context_Ptr context_hdl, char * default_reader, int default_reader_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_reader(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_reader.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_using_server2(context_Ptr context_hdl, bool default_using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    context_hdl->default_using_server2.setValue(default_using_server2);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_using_server2(context_Ptr context_hdl, bool* default_using_server2)
+  {
+    CTimer::get("XIOS").resume();
+    *default_using_server2 = context_hdl->default_using_server2.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_using_server2(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_using_server2.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_context_default_writer(context_Ptr context_hdl, const char * default_writer, int default_writer_size)
+  {
+    std::string default_writer_str;
+    if (!cstr2string(default_writer, default_writer_size, default_writer_str)) return;
+    CTimer::get("XIOS").resume();
+    context_hdl->default_writer.setValue(default_writer_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_context_default_writer(context_Ptr context_hdl, char * default_writer, int default_writer_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(context_hdl->default_writer.getInheritedValue(), default_writer, default_writer_size))
+      ERROR("void cxios_get_context_default_writer(context_Ptr context_hdl, char * default_writer, int default_writer_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_context_default_writer(context_Ptr context_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = context_hdl->default_writer.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_context_output_dir(context_Ptr context_hdl, const char * output_dir, int output_dir_size)
   {
Index: XIOS3/trunk/src/interface/c_attr/icdomain_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 2616)
@@ -42,4 +42,54 @@
 
 
+  void cxios_set_domain_area_1d(domain_Ptr domain_hdl, double* area_1d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(area_1d, shape(extent[0]), neverDeleteData);
+    domain_hdl->area_1d.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domain_area_1d(domain_Ptr domain_hdl, double* area_1d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(area_1d, shape(extent[0]), neverDeleteData);
+    tmp=domain_hdl->area_1d.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domain_area_1d(domain_Ptr domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domain_hdl->area_1d.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_domain_area_2d(domain_Ptr domain_hdl, double* area_2d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,2> tmp(area_2d, shape(extent[0], extent[1]), neverDeleteData);
+    domain_hdl->area_2d.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domain_area_2d(domain_Ptr domain_hdl, double* area_2d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,2> tmp(area_2d, shape(extent[0], extent[1]), neverDeleteData);
+    tmp=domain_hdl->area_2d.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domain_area_2d(domain_Ptr domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domain_hdl->area_2d.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domain_bounds_lat_1d(domain_Ptr domain_hdl, double* bounds_lat_1d, int* extent)
   {
@@ -194,4 +244,50 @@
 
 
+  void cxios_set_domain_chunking_weight_i(domain_Ptr domain_hdl, double chunking_weight_i)
+  {
+    CTimer::get("XIOS").resume();
+    domain_hdl->chunking_weight_i.setValue(chunking_weight_i);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domain_chunking_weight_i(domain_Ptr domain_hdl, double* chunking_weight_i)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight_i = domain_hdl->chunking_weight_i.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domain_chunking_weight_i(domain_Ptr domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domain_hdl->chunking_weight_i.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_domain_chunking_weight_j(domain_Ptr domain_hdl, double chunking_weight_j)
+  {
+    CTimer::get("XIOS").resume();
+    domain_hdl->chunking_weight_j.setValue(chunking_weight_j);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domain_chunking_weight_j(domain_Ptr domain_hdl, double* chunking_weight_j)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight_j = domain_hdl->chunking_weight_j.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domain_chunking_weight_j(domain_Ptr domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domain_hdl->chunking_weight_j.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domain_comment(domain_Ptr domain_hdl, const char * comment, int comment_size)
   {
@@ -928,4 +1024,30 @@
 
 
+  void cxios_set_domain_nvertex_name(domain_Ptr domain_hdl, const char * nvertex_name, int nvertex_name_size)
+  {
+    std::string nvertex_name_str;
+    if (!cstr2string(nvertex_name, nvertex_name_size, nvertex_name_str)) return;
+    CTimer::get("XIOS").resume();
+    domain_hdl->nvertex_name.setValue(nvertex_name_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domain_nvertex_name(domain_Ptr domain_hdl, char * nvertex_name, int nvertex_name_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(domain_hdl->nvertex_name.getInheritedValue(), nvertex_name, nvertex_name_size))
+      ERROR("void cxios_get_domain_nvertex_name(domain_Ptr domain_hdl, char * nvertex_name, int nvertex_name_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domain_nvertex_name(domain_Ptr domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domain_hdl->nvertex_name.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domain_prec(domain_Ptr domain_hdl, int prec)
   {
Index: XIOS3/trunk/src/interface/c_attr/icdomaingroup_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 2616)
@@ -42,4 +42,54 @@
 
 
+  void cxios_set_domaingroup_area_1d(domaingroup_Ptr domaingroup_hdl, double* area_1d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(area_1d, shape(extent[0]), neverDeleteData);
+    domaingroup_hdl->area_1d.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domaingroup_area_1d(domaingroup_Ptr domaingroup_hdl, double* area_1d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(area_1d, shape(extent[0]), neverDeleteData);
+    tmp=domaingroup_hdl->area_1d.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domaingroup_area_1d(domaingroup_Ptr domaingroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domaingroup_hdl->area_1d.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_domaingroup_area_2d(domaingroup_Ptr domaingroup_hdl, double* area_2d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,2> tmp(area_2d, shape(extent[0], extent[1]), neverDeleteData);
+    domaingroup_hdl->area_2d.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domaingroup_area_2d(domaingroup_Ptr domaingroup_hdl, double* area_2d, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,2> tmp(area_2d, shape(extent[0], extent[1]), neverDeleteData);
+    tmp=domaingroup_hdl->area_2d.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domaingroup_area_2d(domaingroup_Ptr domaingroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domaingroup_hdl->area_2d.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domaingroup_bounds_lat_1d(domaingroup_Ptr domaingroup_hdl, double* bounds_lat_1d, int* extent)
   {
@@ -194,4 +244,50 @@
 
 
+  void cxios_set_domaingroup_chunking_weight_i(domaingroup_Ptr domaingroup_hdl, double chunking_weight_i)
+  {
+    CTimer::get("XIOS").resume();
+    domaingroup_hdl->chunking_weight_i.setValue(chunking_weight_i);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domaingroup_chunking_weight_i(domaingroup_Ptr domaingroup_hdl, double* chunking_weight_i)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight_i = domaingroup_hdl->chunking_weight_i.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domaingroup_chunking_weight_i(domaingroup_Ptr domaingroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domaingroup_hdl->chunking_weight_i.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_domaingroup_chunking_weight_j(domaingroup_Ptr domaingroup_hdl, double chunking_weight_j)
+  {
+    CTimer::get("XIOS").resume();
+    domaingroup_hdl->chunking_weight_j.setValue(chunking_weight_j);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domaingroup_chunking_weight_j(domaingroup_Ptr domaingroup_hdl, double* chunking_weight_j)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_weight_j = domaingroup_hdl->chunking_weight_j.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domaingroup_chunking_weight_j(domaingroup_Ptr domaingroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domaingroup_hdl->chunking_weight_j.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domaingroup_comment(domaingroup_Ptr domaingroup_hdl, const char * comment, int comment_size)
   {
@@ -954,4 +1050,30 @@
 
 
+  void cxios_set_domaingroup_nvertex_name(domaingroup_Ptr domaingroup_hdl, const char * nvertex_name, int nvertex_name_size)
+  {
+    std::string nvertex_name_str;
+    if (!cstr2string(nvertex_name, nvertex_name_size, nvertex_name_str)) return;
+    CTimer::get("XIOS").resume();
+    domaingroup_hdl->nvertex_name.setValue(nvertex_name_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_domaingroup_nvertex_name(domaingroup_Ptr domaingroup_hdl, char * nvertex_name, int nvertex_name_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(domaingroup_hdl->nvertex_name.getInheritedValue(), nvertex_name, nvertex_name_size))
+      ERROR("void cxios_get_domaingroup_nvertex_name(domaingroup_Ptr domaingroup_hdl, char * nvertex_name, int nvertex_name_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_domaingroup_nvertex_name(domaingroup_Ptr domaingroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = domaingroup_hdl->nvertex_name.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_domaingroup_prec(domaingroup_Ptr domaingroup_hdl, int prec)
   {
Index: XIOS3/trunk/src/interface/c_attr/icfield_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icfield_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icfield_attr.cpp	(revision 2616)
@@ -164,4 +164,27 @@
 
 
+  void cxios_set_field_chunking_blocksize_target(field_Ptr field_hdl, double chunking_blocksize_target)
+  {
+    CTimer::get("XIOS").resume();
+    field_hdl->chunking_blocksize_target.setValue(chunking_blocksize_target);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_field_chunking_blocksize_target(field_Ptr field_hdl, double* chunking_blocksize_target)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_blocksize_target = field_hdl->chunking_blocksize_target.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_field_chunking_blocksize_target(field_Ptr field_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = field_hdl->chunking_blocksize_target.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_field_comment(field_Ptr field_hdl, const char * comment, int comment_size)
   {
@@ -208,4 +231,78 @@
      CTimer::get("XIOS").resume();
      bool isDefined = field_hdl->compression_level.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_field_compression_params(field_Ptr field_hdl, double* compression_params, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(compression_params, shape(extent[0]), neverDeleteData);
+    field_hdl->compression_params.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_field_compression_params(field_Ptr field_hdl, double* compression_params, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(compression_params, shape(extent[0]), neverDeleteData);
+    tmp=field_hdl->compression_params.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_field_compression_params(field_Ptr field_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = field_hdl->compression_params.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_field_compression_type(field_Ptr field_hdl, const char * compression_type, int compression_type_size)
+  {
+    std::string compression_type_str;
+    if (!cstr2string(compression_type, compression_type_size, compression_type_str)) return;
+    CTimer::get("XIOS").resume();
+    field_hdl->compression_type.setValue(compression_type_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_field_compression_type(field_Ptr field_hdl, char * compression_type, int compression_type_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(field_hdl->compression_type.getInheritedValue(), compression_type, compression_type_size))
+      ERROR("void cxios_get_field_compression_type(field_Ptr field_hdl, char * compression_type, int compression_type_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_field_compression_type(field_Ptr field_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = field_hdl->compression_type.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_field_conversion_by_NetCDF(field_Ptr field_hdl, bool conversion_by_NetCDF)
+  {
+    CTimer::get("XIOS").resume();
+    field_hdl->conversion_by_NetCDF.setValue(conversion_by_NetCDF);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_field_conversion_by_NetCDF(field_Ptr field_hdl, bool* conversion_by_NetCDF)
+  {
+    CTimer::get("XIOS").resume();
+    *conversion_by_NetCDF = field_hdl->conversion_by_NetCDF.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_field_conversion_by_NetCDF(field_Ptr field_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = field_hdl->conversion_by_NetCDF.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
Index: XIOS3/trunk/src/interface/c_attr/icfieldgroup_attr.cpp
===================================================================
--- XIOS3/trunk/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 2614)
+++ XIOS3/trunk/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 2616)
@@ -164,4 +164,27 @@
 
 
+  void cxios_set_fieldgroup_chunking_blocksize_target(fieldgroup_Ptr fieldgroup_hdl, double chunking_blocksize_target)
+  {
+    CTimer::get("XIOS").resume();
+    fieldgroup_hdl->chunking_blocksize_target.setValue(chunking_blocksize_target);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_fieldgroup_chunking_blocksize_target(fieldgroup_Ptr fieldgroup_hdl, double* chunking_blocksize_target)
+  {
+    CTimer::get("XIOS").resume();
+    *chunking_blocksize_target = fieldgroup_hdl->chunking_blocksize_target.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_fieldgroup_chunking_blocksize_target(fieldgroup_Ptr fieldgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = fieldgroup_hdl->chunking_blocksize_target.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_fieldgroup_comment(fieldgroup_Ptr fieldgroup_hdl, const char * comment, int comment_size)
   {
@@ -208,4 +231,78 @@
      CTimer::get("XIOS").resume();
      bool isDefined = fieldgroup_hdl->compression_level.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_fieldgroup_compression_params(fieldgroup_Ptr fieldgroup_hdl, double* compression_params, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(compression_params, shape(extent[0]), neverDeleteData);
+    fieldgroup_hdl->compression_params.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_fieldgroup_compression_params(fieldgroup_Ptr fieldgroup_hdl, double* compression_params, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(compression_params, shape(extent[0]), neverDeleteData);
+    tmp=fieldgroup_hdl->compression_params.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_fieldgroup_compression_params(fieldgroup_Ptr fieldgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = fieldgroup_hdl->compression_params.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_fieldgroup_compression_type(fieldgroup_Ptr fieldgroup_hdl, const char * compression_type, int compression_type_size)
+  {
+    std::string compression_type_str;
+    if (!cstr2string(compression_type, compression_type_size, compression_type_str)) return;
+    CTimer::get("XIOS").resume();
+    fieldgroup_hdl->compression_type.setValue(compression_type_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_fieldgroup_compression_type(fieldgroup_Ptr fieldgroup_hdl, char * compression_type, int compression_type_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(fieldgroup_hdl->compression_type.getInheritedValue(), compression_type, compression_type_size))
+      ERROR("void cxios_get_fieldgroup_compression_type(fieldgroup_Ptr fieldgroup_hdl, char * compression_type, int compression_type_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_fieldgroup_compression_type(fieldgroup_Ptr fieldgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = fieldgroup_hdl->compression_type.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_fieldgroup_conversion_by_NetCDF(fieldgroup_Ptr fieldgroup_hdl, bool conversion_by_NetCDF)
+  {
+    CTimer::get("XIOS").resume();
+    fieldgroup_hdl->conversion_by_NetCDF.setValue(conversion_by_NetCDF);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_fieldgroup_conversion_by_NetCDF(fieldgroup_Ptr fieldgroup_hdl, bool* conversion_by_NetCDF)
+  {
+    CTimer::get("XIOS").resume();
+    *conversion_by_NetCDF = fieldgroup_hdl->conversion_by_NetCDF.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_fieldgroup_conversion_by_NetCDF(fieldgroup_Ptr fieldgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = fieldgroup_hdl->conversion_by_NetCDF.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
